Attribute VB_Name = "modD3D"
Option Explicit

Private Type tVert
  x As Single
  y As Single
  Z As Single
  RHW As Single
  tu0 As Single
  tv0 As Single
  tu1 As Single
  tv1 As Single
End Type

Dim TexC As IDirect3DTexture9
Dim SurfC As IDirect3DSurface9
Dim TexFX As IDirect3DTexture9
Dim Vert(3) As tVert

Public d3d As IDirect3D9
Public Dev As IDirect3DDevice9

Public Sub D3DRender()
  Dev.BeginScene
'  Dev.Clear 0, ByVal 0, D3DCLEAR_TARGET, &H445577, 1, 0

  Dev.SetTexture 0, TexC
  Dev.SetTexture 1, TexFX

  Dev.SetTextureStageState 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1
  Dev.SetTextureStageState 0, D3DTSS_COLORARG1, D3DTA_TEXTURE
  Dev.SetTextureStageState 1, D3DTSS_COLOROP, D3DTOP_MODULATE2X
  Dev.SetTextureStageState 1, D3DTSS_COLORARG1, D3DTA_TEXTURE
  Dev.SetTextureStageState 1, D3DTSS_COLORARG2, D3DTA_CURRENT

  Dev.SetFVF D3DFVF_XYZRHW Or D3DFVF_TEX2
  Dev.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Vert(0), Len(Vert(0))

  Dev.EndScene
  Dev.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Sub D3DInit()
  Dim DispMode As D3DDISPLAYMODE
  Dim d3dpp As D3DPRESENT_PARAMETERS
  Dim SurfFX As IDirect3DSurface9
  Dim x As Long, y As Long
  Dim Ar(HScale - 1, HScale - 1) As Long
  Dim R As Rect

  Set d3d = Direct3DCreate9
  d3d.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DispMode

  d3dpp.Windowed = 1
  d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD
  'd3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE
  d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_ONE
  d3dpp.BackBufferFormat = DispMode.Format
  d3dpp.EnableAutoDepthStencil = 0
  d3dpp.AutoDepthStencilFormat = D3DFMT_D16

  Set Dev = d3d.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING Or D3DCREATE_FPU_PRESERVE, d3dpp)

  Dev.SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
  Dev.SetRenderState D3DRS_ZENABLE, D3DZB_FALSE
  Dev.SetRenderState D3DRS_ALPHABLENDENABLE, D3D_FALSE
  Dev.SetRenderState D3DRS_LIGHTING, 0

'  Dev.SetSamplerState 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR
'  Dev.SetSamplerState 0, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR
'  Dev.SetSamplerState 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR

'  Dev.SetSamplerState 1, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR
'  Dev.SetSamplerState 1, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR
'  Dev.SetSamplerState 1, D3DSAMP_MINFILTER, D3DTEXF_LINEAR

  Dev.CreateTexture WW, HH, 1, D3DUSAGE_NONE, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, TexC
  Set SurfC = TexC.GetSurfaceLevel(0)

  R.Left = 0
  R.Right = HScale
  R.Top = 0
  R.Bottom = HScale
  Dev.CreateTexture HScale, HScale, 1, D3DUSAGE_NONE, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, TexFX
  Set SurfFX = TexFX.GetSurfaceLevel(0)
  For y = 0 To HScale - 1
    For x = 0 To HScale - 1
      Ar(x, y) = Int((1 - Abs(HScale - 1 - y) / HScale) * 255) * &H10101
    Next x
  Next y
  SurfaceSetData SurfFX, R, HScale * HScale * 4, VarPtr(Ar(0, 0))
  Set SurfFX = Nothing

  Vert(0).x = 0
  Vert(0).y = 0
  Vert(0).Z = 0.5
  Vert(0).RHW = 0.5
  Vert(0).tu0 = 0.0001
  Vert(0).tv0 = 0.0001
  Vert(0).tu1 = 0.0001
  Vert(0).tv1 = 0.0001

  Vert(1).x = WW * WScale
  Vert(1).y = 0
  Vert(1).Z = 0.5
  Vert(1).RHW = 0.5
  Vert(1).tu0 = 1.0001
  Vert(1).tv0 = 0.0001
  Vert(1).tu1 = WW + 0.0001
  Vert(1).tv1 = 0.0001

  Vert(2).x = 0
  Vert(2).y = HH * HScale
  Vert(2).Z = 0.5
  Vert(2).RHW = 0.5
  Vert(2).tu0 = 0.0001
  Vert(2).tv0 = 1.0001
  Vert(2).tu1 = 0.0001
  Vert(2).tv1 = HH + 0.0001

  Vert(3).x = WW * WScale
  Vert(3).y = HH * HScale
  Vert(3).Z = 0.5
  Vert(3).RHW = 0.5
  Vert(3).tu0 = 1.0001
  Vert(3).tv0 = 1.0001
  Vert(3).tu1 = WW + 0.0001
  Vert(3).tv1 = HH + 0.0001
End Sub

Public Sub D3DTerminate()
  Set Dev = Nothing
  Set d3d = Nothing
  Set SurfC = Nothing
  Set TexC = Nothing
  Set TexFX = Nothing
End Sub

Public Sub CreateTexFromSprite()
  Dim R As Rect

  R.Left = 0
  R.Right = WW
  R.Top = 0
  R.Bottom = HH
  SurfaceSetData SurfC, R, WW * HH * 4, SprBack.DataPTR(0, 0)
End Sub

Public Sub SurfaceSetData(SurfC As IDirect3DSurface9, R As Rect, ByVal Size As Long, ByVal pData As Long)
  Dim LR As D3DLOCKED_RECT

  SurfC.LockRect LR, R, 0
  MemCpy ByVal LR.pBits, ByVal pData, Size
  SurfC.UnlockRect
End Sub
