Attribute VB_Name = "modDS"
Option Explicit

Dim DSBBang(1) As IDirectSoundBuffer8
Dim BangInd As Long

Dim DSBStep(1) As IDirectSoundBuffer8
Dim StepInd As Long

Dim DSBFire(1) As IDirectSoundBuffer8
Dim FireInd As Long

Dim DSBRub As IDirectSoundBuffer8
Dim DSBFly As IDirectSoundBuffer8
Dim DSBTNT As IDirectSoundBuffer8
Dim DSBDeath As IDirectSoundBuffer8

Dim DS8 As IDirectSound8

Dim SoundDisable As Boolean

Public Sub SoundInit(ByVal hWnd As Long)
  Dim Ar() As Integer
  Dim nf As Integer
  Dim sz As Long

  On Local Error GoTo Err

  Set DS8 = New DirectSound8
  DS8.Initialize ByVal 0
  DS8.SetCooperativeLevel hWnd, DSSCL_NORMAL

  '=======================================================
  DSBCreate DSBBang(0), App.Path & "\Data\Bang.wav"
  Set DSBBang(1) = DS8.DuplicateSoundBuffer(DSBBang(0))

  '=======================================================
  DSBCreate DSBStep(0), App.Path & "\Data\Step.wav"
  Set DSBStep(1) = DS8.DuplicateSoundBuffer(DSBStep(0))

  '=======================================================
  DSBCreate DSBFire(0), App.Path & "\Data\Fire.wav"
  Set DSBFire(1) = DS8.DuplicateSoundBuffer(DSBFire(0))

  '=======================================================
  DSBCreate DSBRub, App.Path & "\Data\Rub.wav"

  '=======================================================
  DSBCreate DSBFly, App.Path & "\Data\Fly.wav"

  '=======================================================
  DSBCreate DSBTNT, App.Path & "\Data\TNT.wav"

  '=======================================================
  DSBCreate DSBDeath, App.Path & "\Data\Death.wav"
  Exit Sub

Err:
  SoundDisable = True
End Sub

Public Sub SoundBang()
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBBang(BangInd).SetVolume -500
  DSBBang(BangInd).SetFrequency Rnd * 5000 + 30000
  DSBBang(BangInd).SetCurrentPosition 0
  DSBBang(BangInd).Play 0, 0, 0
  BangInd = 1 - BangInd
End Sub

Public Sub SoundStep(Optional ByVal v As Long = -1500)
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBStep(StepInd).SetVolume v
  DSBStep(StepInd).SetFrequency Rnd * 5000 + 40000
  DSBStep(StepInd).SetCurrentPosition 0
  DSBStep(StepInd).Play 0, 0, 0
  StepInd = 1 - StepInd
End Sub

Public Sub SoundFire()
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBFire(FireInd).SetVolume -700
  DSBFire(FireInd).SetFrequency Rnd * 3000 + 20000
  DSBFire(FireInd).SetCurrentPosition 0
  DSBFire(FireInd).Play 0, 0, 0
  FireInd = 1 - FireInd
End Sub

Public Sub SoundRub()
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBRub.SetVolume -1000
  DSBRub.SetFrequency 32000
  DSBRub.SetCurrentPosition 0
  DSBRub.Play 0, 0, 0
End Sub

Public Sub SoundFly()
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBFly.SetVolume -900
  DSBFly.SetFrequency 22000
  DSBFly.SetCurrentPosition 0
  DSBFly.Play 0, 0, 0
End Sub

Public Sub SoundTNT()
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBTNT.SetVolume -700
  DSBTNT.SetFrequency 44100
  DSBTNT.SetCurrentPosition 0
  DSBTNT.Play 0, 0, 0
End Sub

Public Sub SoundDeath()
  If SoundDisable Then
    Exit Sub
  End If
  On Local Error Resume Next

  DSBDeath.SetVolume -700
  DSBDeath.SetFrequency 44100
  DSBDeath.SetCurrentPosition 0
  DSBDeath.Play 0, 0, 0
End Sub

Private Sub DSBCreate(DSB As IDirectSoundBuffer8, fName As String, Optional ByVal Freq As Long = 44100)
  Const WAVE_FORMAT_PCM As Long = 1
  Dim DSBD As DSBUFFERDESC
  Dim WF As WAVEFORMATEX
  Dim Ptr As Long
  Dim Ar() As Integer
  Dim nf As Long
  Dim sz As Long
  Dim i As Long

  nf = FreeFile
  Open fName For Binary As #nf
  Get #nf, &H29, sz
  ReDim Ar(sz \ 2 - 1)
  Get #nf, &H2D, Ar()
  Close #nf

  DSBD.dwSize = Len(DSBD)
  DSBD.dwBufferBytes = sz
  DSBD.dwFlags = DSBCAPS_CTRLVOLUME Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_GLOBALFOCUS
  DSBD.lpwfxFormat = VarPtr(WF)

  WF.wFormatTag = WAVE_FORMAT_PCM
  WF.nChannels = 1
  WF.wBitsPerSample = 16
  WF.nSamplesPerSec = Freq
  WF.nBlockAlign = WF.nChannels * WF.wBitsPerSample \ 8
  WF.nAvgBytesPerSec = WF.nSamplesPerSec * WF.nBlockAlign

  DS8.CreateSoundBuffer DSBD, DSB, ByVal 0

  DSB.Lock 0, sz, Ptr, 0, 0, 0, 0
  MemCpy ByVal Ptr, Ar(0), sz
  DSB.Unlock Ptr, sz, 0, 0
End Sub

Public Sub SoundTerminate()
  Dim i As Long

  If SoundDisable Then
    Exit Sub
  End If

  For i = 0 To 1
    DSBBang(i).Stop
    Set DSBBang(i) = Nothing
    DSBStep(i).Stop
    Set DSBStep(i) = Nothing
    DSBFire(i).Stop
    Set DSBFire(i) = Nothing
  Next i
  DSBRub.Stop
  Set DSBRub = Nothing
  DSBFly.Stop
  Set DSBFly = Nothing
  DSBTNT.Stop
  Set DSBTNT = Nothing
  DSBDeath.Stop
  Set DSBDeath = Nothing

  Set DS8 = Nothing
End Sub
