Attribute VB_Name = "modMap"
Option Explicit

Public Const WW As Long = 128, HH As Long = 200, HScale As Long = 4, WScale As Long = HScale * 2
Public SprBack As SR2D_Sprite
Public Const MapW As Long = 16, MapH As Long = 25
Public MapX As Long, MapY As Long
Public Map(MapW * 8, MapH * 8) As Byte
Public BridgeVisible As Boolean

Dim SprMap As SR2D_Sprite
Dim Spr(31) As SR2D_Sprite
Dim Buf(15, 25) As Byte
Dim SprBricks(7) As SR2D_Sprite
Dim SprFire(3) As SR2D_Sprite
Dim SprBridge(3) As SR2D_Sprite
Dim MapTimer As Double

Public Sub MapInit()
  Dim SprTmp As New SR2D_Sprite
  Dim i As Long

  SprTmp.LoadFromFile App.Path & "\..\data\atlas.bmp"
  For i = 0 To 31
    Set Spr(i) = New SR2D_Sprite
    Spr(i).Init 8, 8
  Next i
  For i = 2 To 5
    Spr(i).Draw SprTmp, (i - 2) * -8, 0
  Next i
  For i = 7 To 31
    Spr(i).Draw SprTmp, (i Mod 8) * -8, (i \ 8) * -8
  Next i

  For i = 0 To 7
    Set SprBricks(i) = New SR2D_Sprite
    SprBricks(i).Init 8, 8
    SprBricks(i).Draw SprTmp, i * -8, -32
  Next i

  For i = 0 To 3
    Set SprFire(i) = New SR2D_Sprite
    SprFire(i).Init 8, 8
    SprFire(i).Draw SprTmp, i * -8, -40
  Next i

  For i = 0 To 3
    Set SprBridge(i) = New SR2D_Sprite
    SprBridge(i).Init 8, 8
    SprBridge(i).Draw SprTmp, i * -8 - 32, -40
  Next i

  Set SprBack = New SR2D_Sprite
  SprBack.Init WW, HH
  Set SprMap = New SR2D_Sprite
  SprMap.Init WW, HH
End Sub

Public Sub MapTick()
  Static d1 As Long
  Static d2 As Long
  Dim x As Long, y As Long
  Dim xx As Long, yy As Long
  Dim c As Long

  If Abs(NowTime - MapTimer) > 0.08 Then
    MapTimer = NowTime
    d1 = (d1 + 1) And 3
    d2 = (d2 + 1) Mod 40
    BridgeVisible = d2 <= 28
    For y = 0 To MapH
      yy = y * 8 - 4
      For x = 0 To MapW
        xx = x * 8 - 4
        c = Map(x + MapX, y + MapY)
        If c = 6 Then
          SprMap.Draw SprFire(Int(Rnd * 3.999!)), xx, yy
        ElseIf c = 8 Then
          SprMap.Draw Spr(d1 + 8), xx, yy
        ElseIf c = 9 Then
          SprMap.Draw Spr(d1 + 12), xx, yy
        ElseIf c = 16 Then
          SprMap.Draw Spr(d1 + 16), xx, yy
        ElseIf c = 24 Then
          SprMap.Draw Spr(d1 + 24), xx, yy
        ElseIf c = 20 Then
          SprMap.Draw Spr(d1 + 20), xx, yy
        ElseIf c = 28 Then
          SprMap.Draw Spr(d1 + 28), xx, yy
        ElseIf c = 10 Then
          If BridgeVisible Then
            SprMap.Draw SprBridge(d1), xx, yy
          Else
            SprMap.Draw Spr(1), xx, yy
          End If
        End If
      Next x
    Next y
  End If
End Sub

Public Function TestFloor(ByVal x As Long, ByVal y As Long, ByRef RetSpd As Long) As Boolean
  Dim c As Byte

  If Not TestWall(x, y - 1) Then
    c = Map(x, y)
    If c = 8 Or c = 16 Or c = 24 Then
      RetSpd = -1
      TestFloor = True
    ElseIf c = 9 Or c = 20 Or c = 28 Then
      RetSpd = 1
      TestFloor = True
    ElseIf c = 0 Or c = 2 Or c = 4 Or (c = 10 And BridgeVisible) Then
      RetSpd = 0
      TestFloor = True
    End If
  End If
End Function

Public Function TestWall(ByVal x As Long, ByVal y As Long) As Boolean
  Dim c As Byte

  c = Map(x, y)
  TestWall = c = 0 'Or c = 8 Or c = 9 Or c = 16 Or c = 20 Or c = 24 Or c = 28
End Function

Public Sub MapLoad()
  Dim nf As Long

  nf = FreeFile
  Open App.Path & "\..\data\map1.map" For Binary As #nf
  Get #nf, , Map()
  Close #nf
End Sub

Public Sub MapSelect(ByVal IX As Long, ByVal IY As Long)
  Dim x As Long, y As Long

  SprMap.ClearBuffer 9879876
  MapX = IX
  MapY = IY
  Set Spr(0) = SprBricks(IY \ 25)
  For y = 0 To MapH
    For x = 0 To MapW
      SprMap.Draw Spr(Map(x + MapX, y + MapY)), x * 8 - 4, y * 8 - 4
    Next x
  Next y
  MapTimer = NowTime - 0.1
End Sub

Public Sub MapDraw()
  SprBack.Draw SprMap, 0, 0
  PersDrawTo SprBack
End Sub

Public Sub MapTerminate()
  Dim i As Long

  For i = 0 To 31
    Set Spr(i) = Nothing
  Next i

  For i = 0 To 7
    Set SprBricks(i) = Nothing
  Next i

  For i = 0 To 3
    Set SprFire(i) = Nothing
  Next i

  For i = 0 To 3
    Set SprBridge(i) = Nothing
  Next i

  Set SprBack = Nothing
End Sub
