Attribute VB_Name = "modMath"
Option Explicit

Public Type Vector2
  x As Single
  y As Single
End Type

Public Const Pi As Single = 3.141593

Public Function Vec2(ByVal x As Single, ByVal y As Single) As Vector2
  Vec2.x = x
  Vec2.y = y
End Function

Public Function Vec2Subtract(v1 As Vector2, v2 As Vector2) As Vector2
  Vec2Subtract.x = v1.x - v2.x
  Vec2Subtract.y = v1.y - v2.y
End Function

Public Function Vec2Add(v1 As Vector2, v2 As Vector2) As Vector2
  Vec2Add.x = v1.x + v2.x
  Vec2Add.y = v1.y + v2.y
End Function

Public Function Vec2Normalize(vOut As Vector2, v As Vector2) As Boolean
  Dim iL As Single

  iL = Sqr(v.x * v.x + v.y * v.y)
  If iL > 0 Then
    iL = 1 / iL
    vOut.x = v.x * iL
    vOut.y = v.y * iL
    Vec2Normalize = True
  End If
End Function

Public Function Vec2Scale(v As Vector2, ByVal k As Single) As Vector2
  Vec2Scale.x = v.x * k
  Vec2Scale.y = v.y * k
End Function

Public Function Vec2Length(v As Vector2) As Single
  Vec2Length = Sqr(v.x * v.x + v.y * v.y)
End Function

Public Function Vec2LengthSq(v As Vector2) As Single
  Vec2LengthSq = v.x * v.x + v.y * v.y
End Function

Public Function Vec2CCW(v1 As Vector2, v2 As Vector2) As Single
  Vec2CCW = v1.x * v2.y - v1.y * v2.x
End Function

Public Function Vec2Dot(v1 As Vector2, v2 As Vector2) As Single
  Vec2Dot = v1.x * v2.x + v1.y * v2.y
End Function
