Attribute VB_Name = "modPers"
Option Explicit

Private Enum epMode
  pmRun
  pmFly
  pmLadder
  pmRope
  pmSlide
End Enum

Dim anLeft As New Animation
Dim anRight As New Animation
Dim anUp As New Animation
Dim anJumpL As New Animation
Dim anJumpR As New Animation
Dim an As Animation

Public PersFX As Long, PersFY As Long, PersWantJump As Boolean
Dim PersX As Single, PersY As Single
Dim PersSpdX As Single, PersSpdY As Single
Dim pmMode As epMode
Dim fJumpOld As Boolean
Dim fJump As Boolean

Public Sub PersTick()
  Dim pCX As Long
  Dim pLX As Long, pL2X As Long
  Dim pRX As Long, pR2X As Long
  Dim pCY As Long
  Dim pDY As Long
  Dim pUY As Long
  Dim Spd As Long
  Dim sL As Long, sR As Long

  pCX = Int(PersX)
  pLX = Int(PersX - 0.35)
  pL2X = Int(PersX - 0.45)
  pRX = Int(PersX + 0.35)
  pR2X = Int(PersX + 0.45)
  pCY = Int(PersY - 0.3)
  pDY = Int(PersY + 0.5)
  pUY = pCY - 1

  PersX = PersX + PersSpdX
  PersY = PersY + PersSpdY

  If TestWall(pL2X, pCY) Then
    If PersSpdX < 0 Then PersSpdX = 0
    PersX = pCX + 0.5
  ElseIf TestWall(pR2X, pCY) Then
    If PersSpdX > 0 Then PersSpdX = 0
    PersX = pCX + 0.5
  End If

  If PersWantJump Then
    If fJumpOld = False Then fJump = True
  Else
    fJump = False
  End If
  fJumpOld = PersWantJump

  Select Case pmMode
    Case pmFly
      PersSpdY = (PersSpdY + 0.002) * 0.998
      PersSpdX = PersSpdX * 0.995
      If PersSpdY > 0 And (TestFloor(pLX, pDY, sL) Or TestFloor(pRX, pDY, sR)) Then
        Spd = Sgn(sL + sR)
        PersSpdY = 0
        PersY = pDY
        ChangeMode pmRun
      ElseIf Abs(PersX - (pCX + 0.5)) < 0.1 Then
        If Map(pCX, pCY) = 5 Then
          PersX = pCX + 0.5
          PersSpdX = 0
          PersSpdY = 0
          ChangeMode pmRope
        ElseIf Map(pCX, pCY) = 7 Then
          PersX = pCX + 0.5
          PersSpdX = 0
          ChangeMode pmSlide
        End If
      End If

    Case pmRun
      If TestFloor(pLX, pDY, sL) Or TestFloor(pRX, pDY, sR) Then
        Spd = Sgn(sL + sR)
        PersSpdX = (PersSpdX + PersFX * 0.006 + Spd * 0.002) * 0.8
        If fJump Then
          PersSpdX = PersFX * 0.03
          PersSpdY = -0.075
          PersY = PersY - 0.8
          ChangeMode pmFly
        ElseIf PersFY > 0 And Abs(PersX - (pCX + 0.5)) < 0.1 Then
          If Map(pCX, pDY) = 4 Then
            PersX = pCX + 0.5
            PersY = PersY + 0.1
            PersSpdX = 0
            PersSpdY = 0
            ChangeMode pmRope
          ElseIf Map(pCX, pDY) = 2 Then
            PersX = pCX + 0.5
            PersY = PersY + 0.1
            PersSpdX = 0
            PersSpdY = 0
            ChangeMode pmLadder
          End If
        ElseIf PersFY < 0 And Abs(PersX - (pCX + 0.5)) < 0.1 Then
          If Map(pCX, pCY) = 3 Then
            PersX = pCX + 0.5
            PersY = PersY - 0.1
            PersSpdX = 0
            PersSpdY = 0
            ChangeMode pmLadder
          End If
        End If
      Else
        ChangeMode pmFly
      End If

    Case pmRope
      PersSpdY = PersFY * 0.02
      If TestFloor(pCX, pDY, 0) And PersFY < 0 Then
        PersSpdY = 0
        PersY = pDY
        ChangeMode pmRun
      ElseIf Map(pCX, pCY) <> 5 And Map(pCX, pDY) <> 4 And Map(pCX, pDY) <> 5 Then
        ChangeMode pmFly
      ElseIf fJump And PersFX <> 0 Then
        If PersFX < 0 And Not TestWall(pCX - 1, pCY - 1) And Not TestWall(pCX - 1, pCY - 2) Then
          PersSpdX = -0.03
          PersSpdY = -0.075
          PersX = PersX - 0.15
          ChangeMode pmFly
        ElseIf PersFX > 0 And Not TestWall(pCX + 1, pCY - 1) And Not TestWall(pCX + 1, pCY - 2) Then
          PersSpdX = 0.03
          PersSpdY = -0.075
          PersX = PersX + 0.15
          ChangeMode pmFly
        End If
      End If

    Case pmLadder
      PersSpdY = PersFY * 0.02
      If TestFloor(pCX, pDY, 0) And PersFY < 0 And Map(pCX, pCY) <> 3 Then
        PersSpdY = 0
        PersY = pDY
        ChangeMode pmRun
      ElseIf Map(pCX, pCY) <> 3 And Map(pCX, pDY) <> 2 And Map(pCX, pDY) <> 3 Then
        ChangeMode pmFly
      End If

    Case pmSlide
      PersSpdY = (PersSpdY + 0.002) * 0.998
      If PersSpdY > 0 And TestFloor(pCX, pDY, sL) Then
        PersSpdX = 0
        PersSpdY = 0
        PersY = pDY
        ChangeMode pmRun
      End If
  End Select

  If (PersX - MapX) > 16.6 Or (PersX - MapX) < 0.4 Or (PersY - MapY) > 25.6 Or (PersY - MapY) < 0.4 Then
    MapSelect Int((PersX - 0.5) / 16) * 16, Int((PersY - 0.5) / 25) * 25
  End If
End Sub

Private Sub ChangeMode(ByVal pm As epMode)
  pmMode = pm
  fJump = False
End Sub

Public Sub PersInit()
  anLeft.Init 4, 1, 8, 20, 4, 20, App.Path & "\..\data\anL.png", 16
  anRight.Init 4, 1, 8, 20, 4, 20, App.Path & "\..\data\anL.png", 16, TrFlipX
  anUp.Init 4, 1, 8, 20, 4, 20, App.Path & "\..\data\anU.png", 16
  anJumpL.Init 4, 1, 8, 20, 4, 20, App.Path & "\..\data\anJ.png", 16
  anJumpR.Init 4, 1, 8, 20, 4, 20, App.Path & "\..\data\anJ.png", 16, TrFlipX
  Set an = anJumpL

  PersX = 8.5
  PersY = 4
  PersSpdX = 0
  PersSpdY = 0
  pmMode = pmFly
End Sub

Public Sub PersDrawTo(Spr As SR2D_Sprite)
  Static T As Single

  Select Case pmMode
    Case pmRun
      If PersFX < 0 Then
        Set an = anLeft
      ElseIf PersFX > 0 Then
        Set an = anRight
      End If
    Case pmRope, pmLadder
      Set an = anUp
    Case pmFly
      If PersSpdX < 0 Then
        Set an = anJumpL
      Else
        Set an = anJumpR
      End If
    Case Else
  End Select
  an.DrawTo Spr, (PersX - MapX) * 8 - 4, (PersY - MapY) * 8 - 4, NowTime - T
  T = NowTime
End Sub

Public Sub PersTerminate()
  Set anLeft = Nothing
  Set anRight = Nothing
  Set anUp = Nothing
  Set anJumpL = Nothing
  Set anJumpR = Nothing
End Sub
